'****************************************************************************
'* BASM version 6.5             Small BASIC to assembler translator         *
'* by Kevin Diggins                                                         *
'* Compiled with PowerBASIC 3.2   Command Line Compiler                     *
'* Source Code Public Release                                               *
'****************************************************************************

$Cpu       8086
$Float     Procedure
$Optimize  Speed
$Lib       All Off
$Error     All Off
$Compile   Exe
$String    1

DEFINT A-Z

ON ERROR GOTO ERRORHANDLER

Dash$       =   ";" + REPEAT$(70,"*")
Me$         =   "Kevin Diggins "
Version$    =   "6.5"
CmdClone$   =   UCASE$(COMMAND$)
ForceCom    =   INSTR(CmdClone$,"/C")
IF ForceCom     THEN Build "$COM"
ProjName$   =   REMOVE$(CmdClone$,"/C")
ProjName$  =   EXTRACT$(ProjName$,".")
MemModel   =   2    'do NOT remove ... this ties to the SwapStakName
%True      =  -1
%False     =   0

' Define the datatypes

%StrLit    =   1
%StrVar    =   2
%NumVar    =   3
%Number    =   4
%Arith     =   5
%Func      =   6

' Define the generation types

%ExeType   =   1
%ComType   =   2

%TableSize = 500

DIM  BasicCode$     (32750)
DIM  NearData$      (%TableSize)
DIM  FarData$       (%TableSize)
DIM  VarName$       (%TableSize)
DIM  StrArrayName$  (%TableSize)        'holds the names of String Arrays
DIM  LocalName$     (%TableSize)

DIM  LocalTable$    (256)
DIM  StrArrayLeng   (256)         'holds the unit length of a string array
DIM  IfThenStack    (256)         '\
DIM  ElseStack      (256)         ' \
DIM  LoopStack      (256)         '  /    keeps track of nested cases
DIM  ForStack       (256)         ' /
DIM  RepeatStack    (256)         '/

DIM  FileHandles    (25)          '
DIM  Proc$          (256,22)      '(1)=name$  (2)=ParmCnt  (3-22)=params
DIM  Stk$           (256)         'used in Parse & QuikParse Functions
DIM  Externals$     (256)         'holds the names of DECLARED subs & funcs
DIM  ConstName$     (256)         'holds the names of CONST's ( aka EQU )


'***************************************************************************
LoopPush 1                        'Initialize the Do - Loop Stack
'***************************************************************************

SourceFlag%  =         1          'include source lines in assembly (default)
BasmStrings  =        81          'default string size
SysStack     =       256          'default stack size
CodeType     =  %ExeType          'default to EXE Code
ExtrnCnt     =         0          'tracks the External Sub & Func stack

'**************************************************************************

Func$ =         " ASC BIN$ BIN2DEC CHR$ CSRLIN CURDIR$ DATE$ DIR$ EXTRACT$"
Func$ = Func$ + " GETKEY INSTAT INSTR LCASE$ LEN LTRIM$ MID$ NOT ABS AND"
Func$ = Func$ + " OR PEEK POS REMOVE$ REPEAT$ RND RTRIM$ SPACE$ STR$ INKEY"
Func$ = Func$ + " TIME$ TRIM$ UCASE$ VAL VERIFY VIDEOCARD XOR HEX$ WITH"
Func$ = Func$ + " IN THEN EQ LE GE NE GT LT TO AS OUTPUT INPUT SCAN SGN"
Func$ = Func$ + " MOD LEFT$ RIGHT$ TICKS POW VARPTR PEEKI VARSEG POINT"
Func$ = Func$ + " RANDOM ALLOC FREEMEM CODEPTR CODESEG USTR$ ASC2 CPUID"
Func$ = Func$ + " TRUE FALSE CHS CURDRIVE$ TAB ATTRIB EXIST STDIN$ INP "

'**************************************************************************

VarName$(1) = "EOF"
VarName$(2) = "ERR"
VarName$(3) = "FGCOLOR"
VarName$(4) = "BGCOLOR"
VarName$(5) = "DEFSEG"
VarName$(6) = "COMMAND$"
VarName$(7) = "TIME$"
VarName$(8) = "DATE$"

Literals    =  8
%Offset     =  8

COLOR 14,0

'***************************************************************************
? "BASM " + Version$ + " (BASIC to 286 Assembly Language Compiler)  (c) 1999 by " + Me$
'***************************************************************************

COLOR 7,0

IF COMMAND$ = "" THEN
  COLOR 12,0
  PRINT "Usage: BASM [Drive]\[Path]\FileName[.BAS]" ;
  COLOR 7,0
  PRINT
  END
END IF

Destin$   = EXTRACT$(ProjName$,".") + ".ASM"  'destination asm file
SubProcs$ = EXTRACT$(ProjName$,".") + ".PRC"  'temporary procedures file
PRINT "Creating ";UCASE$(Destin$)
StartTime@ = Timer

PreProcess

FOR LineNo    =  1 to CodeLines
  SourceLine$  =  BasicCode$(LineNo)
  Tokens       =  Parse(SourceLine$)

  IF Tokens THEN        '___________[ Don't parse empty lines ]___________

    Switch$ = UCASE$(Stk$(1))
    ChangeQuotedStrings
    ConvertLocalVariableNames
    UpdateProcPointer

    SELECT CASE Switch$

'Ŀ
' Assignment Statement 
'

      CASE "="

      PrintSrc

      IF IsUsrFunc(Stk$(2)) THEN
        IF DataType(Stk$(2)) = %StrVar THEN
          Stk$(2) = "$StrFunc"
        ELSE
          Stk$(2) = "AX"
        END IF
      END IF

'****************************************************************
      Var$ = AddVar$(Stk$(2))    '   [ get the receiving Variable  ]
'****************************************************************

      IF IsUsrFunc(Stk$(3)) THEN

        FOR Tmp = Tokens TO 4 STEP -1
          Tmp$ = Stk$(Tmp)
          ResolveTmp
          TheDataType = DataType(Tmp$)

          SELECT CASE TheDataType

            CASE  %NumVar, %Number
            Emit "Push " + Tmp$

            CASE %StrVar
            Emit "Push Offset " + Tmp$
          END SELECT

        NEXT

        Emit "Call " + Stk$(3)

        IF DataType(Stk$(2)) = %StrVar THEN

          Use.MoveStr = %True

          IF UCASE$(VAR$) <> "$STRFUNC" THEN
            Emit "Mov  SI,Offset $StrFunc"
            Emit "Mov  DI,Offset " + Var$
            Emit "Call MoveStr"
          END IF

        ELSE

          Resolve2
          IF Stk$(2) <> "AX" THEN
            Emit "Mov  " + Stk$(2) + ",AX"
          END IF
        END IF
        EXIT SELECT      'We've assigned a User Function so we can leave now
      END IF

'**************************************************************************

      IF DataType(Var$) = %StrVar THEN         'Is it a string expression?

        Use.Work0   = %True
        Use.ClrWork = %True
        Emit "Call ClrWork"

        FOR Ptr = 3 TO Tokens                   'Yes, so build the string
          Value$ = Stk$(Ptr)

          IF DataType(Value$) = %Func THEN
            TmpFunc$ = UCASE$(Value$)

            SELECT CASE TmpFunc$

              CASE "STDIN$"
              Use.Stdin   = %True
              Emit "Call Stdin$"
              EmitConcatCode



              CASE "MID$"
              Use.Mid     =  %True
              Use.ClrWork =  %True
              Resolve Stk$(Ptr+1)
              Resolve Stk$(Ptr+2)
              Resolve Stk$(Ptr+3)
              LoadRegister "SI",Stk$(Ptr+1)
              Emit "Mov  AX," + Stk$(Ptr+2)
              IF Stk$(Ptr+3) = "" OR Stk$(Ptr+3) = "+" THEN
                Stk$(Ptr+3) = "MaxString"
              END IF
              Emit "Mov  BX," + Stk$(Ptr+3)
              Emit "Call Mid$
              INCR Ptr,3
              EmitConcatCode




              CASE "UCASE$"
              Use.Ucase = %True
              INCR Ptr
              ResolvePtr
              LoadRegister "SI",Stk$(Ptr)
              Emit "Mov  DI,Offset $_1_"
              Emit "Call MoveStr"
              Emit "Mov  AX,Offset $_1_"
              Emit "Call Ucase$"
              EmitConcatCode


              CASE "LCASE$"
              Use.Lcase  = %True
              INCR Ptr
              ResolvePtr
              LoadRegister "SI",Stk$(Ptr)
              Emit "Mov  DI,Offset $_1_"
              Emit "Call MoveStr"
              Emit "Mov  AX,Offset $_1_"
              Emit "Call Lcase$"
              EmitConcatCode



              CASE "LEFT$"
              Use.Left    =  %True
              Resolve Stk$(Ptr+1)
              Resolve Stk$(Ptr+2)
              Push Stk$(Ptr+2)
              Push Stk$(Ptr+1)
              Emit "Call Left$"
              INCR Ptr,2
              EmitConcatCode



              CASE "RIGHT$"
              Use.Right   =  %True
              Use.Len     =  %True
              Resolve Stk$(Ptr+1)
              Resolve Stk$(Ptr+2)
              Push Stk$(Ptr+2)
              Push Stk$(Ptr+1)
              Emit "Call Right$"
              INCR Ptr,2
              EmitConcatCode




              CASE "TRIM$"
              Use.Work2 = %True
              Use.Ltrim = %True
              Use.Rtrim = %True
              Use.Trim  = %True
              INCR Ptr
              ResolvePtr
              LoadRegister "SI",Stk$(Ptr)
              Emit "Call Trim$"
              EmitConcatCode



              CASE "LTRIM$"
              Use.Work2 = %True
              Use.Ltrim = %True
              INCR Ptr
              ResolvePtr
              LoadRegister "SI",Stk$(Ptr)
              Emit "Call Ltrim$"
              EmitConcatCode




              CASE "RTRIM$"
              Use.Work2 = %True
              Use.Rtrim = %True
              INCR Ptr
              ResolvePtr
              LoadRegister "SI",Stk$(Ptr)
              Emit "Call Rtrim$"
              EmitConcatCode



              CASE "EXTRACT$"
              Use.Work2 = %True
              Use.Extract = %True
              Resolve Stk$(Ptr+1)
              LoadRegister "SI",Stk$(Ptr+1)
              Resolve Stk$(Ptr+2)
              LoadRegister "DI",Stk$(Ptr+2)
              Emit "Call Extract$"
              INCR Ptr,2
              EmitConcatCode


              CASE "REMOVE$"
              Use.Work2      =   %True
              Use.Work3      =   %True
              Use.Work4      =   %True
              Use.MoveStr    =   %True
              Use.Remove     =   %True
              Use.Instr      =   %True
              Use.ConcatWork =   %True
              Use.Mid        =   %True

              Resolve Stk$(Ptr+1)
              Resolve Stk$(Ptr+2)
              Push Stk$(Ptr+2)
              Push Stk$(Ptr+1)
              Emit "Call Remove$"
              INCR Ptr,2
              EmitConcatCode


              CASE "DIR$"
              Use.Work0     = %True
              Use.TrapError = %True
              Use.Dta       = %True
              IF Tokens > 3 THEN                      'find first call
                Use.FindFirst = %True
                Resolve Stk$(Ptr+1)                    'file mask
                Resolve Stk$(Ptr+2)
                LoadRegister "SI",Stk$(Ptr+1)
                LoadRegister "CX",Stk$(Ptr+2)          'file search attributes
                Emit "Call FindFirst"
                INCR Ptr,2
                EmitConcatCode
              ELSE                                    'find next call
                Use.FindNext  = %True
                Emit "Mov  DI,Offset $_0_"
                Emit "Mov  [DI],Byte Ptr 0"
                Emit "Call FindNext"
                EmitConcatCode
                Stk$(3)="$_0_"
              END IF


              CASE "CURDIR$"
              Use.Work2 =   %True
              LoadRegister "SI","$_1_"
              Emit "Mov  DL,0"
              Emit "Mov  AH,47h"
              Emit "Int  21h"
              EmitConcatCode


              CASE "CURDRIVE$"
              Use.Curdrive = %True
              Emit "Call Curdrive$"
              EmitConcatCode


              CASE "TIME$"
              Use.Time   = %True
              Emit "Call Time"
              EmitConcatCode


              CASE "DATE$"
              Use.Date   = %True
              Emit "Call Date"
              EmitConcatCode


              CASE "REPEAT$"
              Use.MoveStr = %True
              Use.Repeat =  %True
              Resolve Stk$(Ptr+1)
              Resolve Stk$(Ptr+2)
              Push Stk$(Ptr+2)
              Push Stk$(Ptr+1)
              Emit "Call Repeat$"
              INCR Ptr,2
              EmitConcatCode


              CASE "CHR$"
              INCR Ptr
              ResolvePtr
              Emit "Mov  DI,Offset $_1_"
              Emit "Mov  AX," + Stk$(Ptr)
              Emit "Mov  [Byte Ptr DI],AX"
              Emit "Xor  BX,BX"
              Emit "Mov  [Byte Ptr DI+1],BX"
              EmitConcatCode



              CASE "STR$"
              Use.Str  = %True
              INCR Ptr
              ResolvePtr
              Emit "Mov  DI,Offset $_1_"
              Emit "Mov  AX," + Stk$(Ptr)
              Emit "Xor  BX,BX"
              Emit "Call Str$"
              EmitConcatCode


              CASE "USTR$"
              Use.Ustr = %True
              INCR Ptr
              ResolvePtr
              Emit "Mov  DI,Offset $_1_"
              Emit "Mov  AX," + Stk$(Ptr)
              Emit "Call Ustr$"
              EmitConcatCode



              CASE "HEX$"
              Use.Hex    = %True
              INCR Ptr
              ResolvePtr
              Push Stk$(Ptr)
              Emit "Call Hex$"
              EmitConcatCode


              CASE "BIN$"
              Use.MovStr = %True
              Use.Bin    = %True
              INCR Ptr
              ResolvePtr
              Emit "Mov  DX," + Stk$(Ptr)
              Emit "Call Bin$"
              EmitConcatCode


              CASE "SPACE$"
              Use.Space =  %True
              INCR Ptr
              ResolvePtr
              Emit "Mov  DI,Offset $_1_"
              Emit "Mov  AX," + Stk$(Ptr)
              Emit "Call Space$"
              EmitConcatCode
            END SELECT
          END IF


          IF DataType(Value$) = %StrVar THEN
            Use.Concat2 =  %True
            Resolve Value$
            IF UCASE$(Value$) = "COMMAND$" THEN Use.Command = %True
            IF Tokens > 3 THEN
              LoadRegister "SI",Value$
              Use.ConcatWork = %True
              Emit "Call ConcatWork"
            END IF
          END IF
        NEXT

        Use.MoveStr  = %True
        Use.Assign   = %True

        IF Tokens = 3 AND DataType(Stk$(3)) <> %Func THEN
          Resolve2
          Resolve3
          LoadRegister "SI",Stk$(3)
          LoadRegister "DI",Stk$(2)
          Emit "Call MoveStr"
        ELSE
          Resolve Var$
          LoadRegister "DI",Var$
          Emit "Call Assign"
        END IF
        EXIT SELECT
      END IF

'*************************************************************************
'The Variable had better be an Integer Variable when we hit this point
'*************************************************************************

      Resolve Var$
      Resolve3

      IF Tokens = 3 AND IsInteger(Stk$(3)) THEN
        Emit "Mov  " + Var$ + "," + Stk$(3)
        Exit Select
      END IF


'* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'                                                                  *
' This is non essential and is meant as an optimisation only       *
'                                                                  *
'* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

      IF Tokens = 5 AND UCASE$(Stk$(2)) = UCASE$(Stk$(3)) AND Stk$(4) = "+" AND Stk$(5) = "1" THEN
        Emit "Inc  " + Var$
        Exit Select
      END IF


      IF Tokens = 4 AND UCASE$(Stk$(2)) = UCASE$(Stk$(3)) AND Stk$(4) = "-1" THEN
        Emit "Dec  " + Var$
        Exit Select
      END IF

      IF Tokens = 5 AND UCASE$(Stk$(2)) = UCASE$(Stk$(3)) AND Stk$(4) = "+" AND IsInteger(Stk$(5))  THEN
        Emit "Add  " + Var$ + "," + Stk$(5)
        Exit Select
      END IF

      IF Tokens = 4 AND UCASE$(Stk$(2)) = UCASE$(Stk$(3)) AND (Instr(Stk$(4),"-") > 0)  THEN
        Emit "Sub  " + Var$ + "," + Remove$(Stk$(4),"-")
        Exit Select
      END IF


'* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *


      IF Tokens = 3 AND DataType(Stk$(3)) <> %Func THEN
        IF IsUsrFunc(Stk$(2)) THEN
          Emit "Mov  AX," + Stk$(3)
          EXIT SELECT
        ELSE
          Emit "Mov  AX," + Stk$(3)
          Emit "Mov  " + Var$ + ",AX"
          Exit Select
        END IF
      END IF



      Math$ = "+"

      Emit "Xor  AX,AX"

      FOR Ptr = 3 TO Tokens
        Value$ = Stk$(Ptr)
        Resolve Value$

        IF DataType(Value$) = %NumVar THEN
          Value$ = AddVar$(Value$)
        END IF

        SELECT CASE Value$

          CASE "+" , "-" , "*" , "/"
          Math$ = Value$
          INCR Ptr
          Value$ = Stk$(Ptr)
          Resolve Value$

        END SELECT

        TheDataType = DataType(Value$)

        IF TheDataType = %Number OR TheDataType = %NumVar THEN
          ArithFlag = %True
          DoArithetic
        END IF

        IF TheDataType = %Func THEN

          IF Tokens > 3 THEN
            Emit "Mov  $Var0,AX"
          END IF



          TmpFunc$ = UCASE$(Value$)

          SELECT CASE TmpFunc$

            CASE "ALLOC"
            INCR Ptr
            ResolvePtr
            Emit "Mov  AX," + Stk$(Ptr)
            Emit "Call Alloc"
            DoArithetic
            Use.Alloc = %True


            CASE "INP"
            INCR Ptr
            ResolvePtr
            Emit "Push AX"
            Emit "In   AL," + Stk$(Ptr)
            Emit "Xor  AH,AH"
            Emit "Pop  BX"
            Emit "Add  BX,AX"
            DoArithetic
            Use.Len = %True


            CASE "LEN"
            INCR Ptr
            ResolvePtr
            LoadRegister "SI",Stk$(Ptr)
            Emit "Call Len"
            DoArithetic
            Use.Len = %True


            CASE "EXIST"
            INCR Ptr
            ResolvePtr
            Emit "Push Offset " + Stk$(Ptr)
            Emit "Call Exist"
            DoArithetic
            Use.Exist = %True


            CASE "ASC2"
            Resolve Stk$(Ptr+2)
            Emit "Push " + Stk$(Ptr+2)
            Resolve Stk$(Ptr+1)
            Emit "Push Offset " + Stk$(Ptr+1)
            Emit "Call Asc2"
            INCR Ptr,2
            DoArithetic
            Use.Asc2 = %True


            CASE "TICKS"
            Emit "Call Ticks"
            DoArithetic
            Use.Peek  = %True
            Use.Ticks = %True


            CASE "CPUID"
            Emit "Call CpuID"
            DoArithetic
            Use.CpuID = %True


            CASE "INSTR"
            INCR Ptr
            ResolvePtr
            LoadRegister "DI",Stk$(Ptr)
            INCR Ptr
            ResolvePtr
            LoadRegister "SI",Stk$(Ptr)
            Emit "Call _Instr"
            DoArithetic
            Use.Instr = %True
            Use.Len   = %True
            Use.Strcompare = %True


            CASE "VIDEOCARD"
            Use.VideoCard = %True
            Emit "Call VideoCard"
            DoArithetic




            CASE "CODEPTR"
            INCR PTR
            Emit "Mov  AX,Offset " + Stk$(Ptr)
            DoArithetic



            CASE "CODESEG"
            Emit "Push  CS"
            Emit "Pop   AX"
            DoArithetic




            CASE "VERIFY"
            Use.Work0   =  %True
            Use.Work1   =  %True
            Use.Work2   =  %True
            Use.Work3   =  %True
            Use.Work4   =  %True
            Use.Concat2 =  %True
            Use.Len     =  %True
            Use.MoveStr =  %True
            Use.Verify  =  %True
            Use.Instr   =  %True
            INCR Ptr
            V1$ = Stk$(Ptr)
            INCR Ptr
            V2$ = Stk$(Ptr)
            Resolve V1$
            Resolve V2$
            Push V2$
            Push V1$
            Emit "Call Verify"
            DoArithetic



            CASE "POS"
            Emit "Call GetCursor"
            Emit "Mov  AX,$Xcur"
            DoArithetic



            CASE "FREEMEM"
            Emit "Call Freemem"
            DoArithetic
            Use.Freemem = %True



            CASE "CSRLIN"
            Emit "Call GetCursor"
            Emit "Mov  AX,$Ycur"
            DoArithetic


            CASE "NOT"
            INCR  Ptr
            ResolvePtr
            Emit "Mov  AX," + Stk$(Ptr)
            Emit "Not  AX"
            Emit "Mov  $Var0,AX"
            Emit "Xor  AX,AX"
            DoArithetic


            CASE "VARPTR"
            INCR  Ptr
            ResolvePtr
            Emit "Mov  AX,Offset " + Stk$(Ptr)
            Emit "Mov  $Var0,AX"
            Emit "Xor  AX,AX"
            DoArithetic



            CASE "VARSEG"
            INCR  Ptr
            Emit "Push $DataSeg
            Emit "Pop  AX"
            DoArithetic



            CASE "OR"
            INCR Ptr
            ResolvePtr
            Emit "Or   AX," + Stk$(Ptr)
            Emit "Mov  $Var0,AX"
            Emit "Xor  AX,AX"
            DoArithetic


            CASE "XOR"
            INCR Ptr
            ResolvePtr
            Emit "Xor  AX," + Stk$(Ptr)
            Emit "Mov  $Var0,AX"
            Emit "Xor  AX,AX"
            DoArithetic



            CASE "AND"
            INCR Ptr
            ResolvePtr
            Emit "And  AX," + Stk$(Ptr)
            Emit "Mov  $Var0,AX"
            Emit "Xor  AX,AX"
            DoArithetic



            CASE "ASC"
            INCR Ptr
            ResolvePtr
            Emit "Mov  AL,[" + Stk$(Ptr) + "]"
            DoArithetic



            CASE "POINT"
            Use.Point = %True
            Resolve Stk$(Ptr+2)
            Emit "Push " + Stk$(Ptr+2)
            Resolve Stk$(Ptr+1)
            Emit "Push " + Stk$(Ptr+1)
            Emit "Call Point
            INCR Ptr,2
            DoArithetic



            CASE "GETKEY"
            Emit "Call GetKey"
            DoArithetic
            Use.GetKey = %True


            CASE "INKEY"
            Emit "Call InKey"
            DoArithetic
            Use.InKey = %True


            CASE "RND"
            Emit "Call Rnd"
            DoArithetic
            Use.Rnd = %True


            CASE "SGN"
            INCR Ptr
            ResolvePtr
            Emit "Push " + Stk$(Ptr)
            Emit "Call Sgn"
            DoArithetic
            Use.Sgn = %True


            CASE "RANDOM"
            INCR Ptr
            ResolvePtr
            Emit "Mov  AX," + Stk$(Ptr)
            Emit "Call Random"
            DoArithetic
            Use.Random = %True


            CASE "CHS"
            INCR Ptr
            ResolvePtr
            Emit "Mov  AX," + Stk$(Ptr)
            Emit "Neg  AX"
            DoArithetic



            CASE "MOD"
            Decr Ptr
            ResolvePtr
            Emit "Push " + Stk$(Ptr)
            INCR Ptr,2
            ResolvePtr
            Emit "Push " + Stk$(Ptr)
            Emit "Call Modd"
            DoArithetic
            Use.Mod = %True


            CASE "ABS"
            INCR Ptr
            ResolvePtr
            Emit "Mov  AX," + Stk$(Ptr)
            Emit "Call _Abs"
            DoArithetic
            Use.Abs = %True


            CASE "SCAN"
            Resolve Stk$(Ptr+1)  'array
            Resolve Stk$(Ptr+2)  'element
            Resolve Stk$(Ptr+3)  'array size
            Push Stk$(Ptr+3)
            Push Stk$(Ptr+2)
            Push Stk$(Ptr+1)
            Emit "Call Scan"
            DoArithetic
            INCR Ptr,3
            Use.Work0      =  %True
            Use.Scan       =  %True
            Use.MoveStr    =  %True
            Use.StrCompare =  %True
            Use.ArrayGet   =  %True
            Use.ArrayPut   =  %True


            CASE "PEEK"
            INCR Ptr
            ResolvePtr
            Emit "Mov  AX," + Stk$(Ptr)
            Emit "Call Peek"
            DoArithetic
            Use.Peek = %True


            CASE "PEEKI"
            INCR Ptr
            ResolvePtr
            Emit "Mov  AX," + Stk$(Ptr)
            Emit "Call PeekI"
            DoArithetic
            Use.Peeki = %True


            CASE "VAL"
            INCR Ptr
            ResolvePtr
            LoadRegister "DI",Stk$(Ptr)
            Emit "Call Val"
            DoArithetic
            Use.VAL = %True


            CASE "BIN2DEC"
            INCR Ptr
            ResolvePtr
            Push Stk$(Ptr)
            Emit "Call Bin2Dec"
            DoArithetic

            Use.Bin2Dec =  %True
            Use.Work0   =  %True
            Use.Val     =  %True
            Use.ClrWork =  %True
            Use.Mid     =  %True
            Use.assign  =  %True
            Use.MoveStr =  %True
            Use.Concat2 =  %True



            CASE "POW"
            V1$ = Stk$(Ptr + 1)
            V2$ = Stk$(Ptr + 2)
            Resolve V1$
            Resolve V2$
            Push V2$
            Push V1$
            INCR Ptr,2
            Emit "Call Pow"
            DoArithetic
            Use.Pow = %True



            CASE "INSTAT"
            Emit "Call Instat"
            DoArithetic
            Use.Instat = %True


            CASE "TRUE"
            Emit "Mov  AX,-1"
            DoArithetic


            CASE "FALSE"
            Emit "Xor  AX,AX"
            DoArithetic


            CASE "ATTRIB"
            INCR Ptr
            ResolvePtr
            Emit  "Mov  DX,Offset " + Stk$(Ptr)
            Emit  "Mov  AX,4300h"
            Emit  "Int  21h
            DoArithetic

          END SELECT
        END IF
        Math$="+"
      NEXT


      IF Var$ <> "AX" THEN
        Emit "Mov  " + Var$ + ",AX"
      END IF



'Ŀ
'  IF  Statement  
'

      CASE "IF"

      PrintSrc

      IF INSTR(Stk$(2),ANY "$" + CHR$(34)) THEN     '*** compare Strings ***
        Resolve2
        Resolve4
        LoadRegister "SI",Stk$(2)
        LoadRegister "DI",Stk$(4)
        Emit "Call StrCompare"
        Use.StrCompare  = %True
      ELSE                                          '*** compare Numerics ***
        Resolve2
        Resolve4
        IF NOT IsInteger(Stk$(4)) THEN
          IF Stk$(2) = "0" THEN
            Emit "Xor  AX,AX"
          ELSE
            Emit "Mov  AX," + Stk$(2)
          END IF
          Emit "Cmp  AX," + Stk$(4)
        ELSE
          Emit "Cmp  " + Stk$(2) + "," + Stk$(4)
        END IF
      END IF

'*** Common to both data types ***

      INCR itLevel
      IfThenPush itLevel

      SELECT CASE Stk$(3)

        CASE "EQ"
        JmpType$="Je "


        CASE "LT"
        JmpType$="Jl "


        CASE "GT"
        JmpType$="Jg "


        CASE "LE"
        JmpType$="Jle"


        CASE "GE"
        JmpType$="Jge"

        CASE "NE"
        JmpType$="Jne"

      END SELECT

      IF InProc THEN
        LocalJmp$=Cap$(ProcName$)
      ELSE
        LocalJmp$=""
      END IF

      Emit JmpType$   +  "  "       +  LocalJmp$     + "_True_"  + Num$(itLevel)
      Emit "Jmp  "    +  LocalJmp$  +  "_EndIf_"     + Num$(itLevel)
      Emit LocalJmp$  +  "_True_"   +  Num$(itLevel) + ":"


'Ŀ
'  ELSE  Statement  
'

      CASE "ELSE"
      PrintSrc

      IF InProc THEN
        LocalJmp$ = Cap$(ProcName$)
      ELSE
        LocalJmp$ = ""
      END IF

      Tmp = IfThenPop
      IfThenPush 0
      ElsePush Tmp

      Emit "Jmp "    +   LocalJmp$   +  "_EndIf_"  +  Num$(Tmp) + "A"
      Emit LocalJmp$ + "_EndIf_"     +   Num$(Tmp) + ":"


'Ŀ
'  ENDIF Statement  
'

      CASE "ENDIF"
      PrintSrc

      IF InProc THEN
        LocalJmp$ = Cap$(ProcName$)
      ELSE
        LocalJmp$ = ""
      END IF

      Tmp = IfThenPop

      IF Tmp > 0 THEN
        Endif$ = LocalJmp$ + "_EndIf_" + Num$(Tmp) + ":"
        Emit Endif$
        EXIT SELECT   '<< bug fix -- added 9/13/98 fixing nesting errors
      END IF

      Tmp = ElsePop

      IF Tmp = 0 THEN ElsePush 0

      IF Tmp > 0 THEN
        Endif$ = LocalJmp$ + "_EndIf_" + Num$(Tmp) + "A:"
        Emit Endif$
      END IF


'Ŀ
'  DO STATEMENT  
'

      CASE "DO"
      PrintSrc
      INCR LoopVar
      LoopPush LoopVar

      IF InProc THEN
        LocalDo$ = Cap$(ProcName$)
      ELSE
        LocalDo$ = ""
      END IF

      Emit LocalDo$ + "DoLoop_" + Num$(LoopVar) + ":"


'Ŀ
'  LOOP STATEMENT  
'

      CASE "LOOP"
      PrintSrc

      IF InProc THEN
        LocalDo$ = Cap$(ProcName$)
      ELSE
        LocalDo$ = ""
      END IF

      InLoop = LoopPop
      Emit "Jmp "    +  LocalDo$ + "DoLoop_"    + Num$(InLoop)
      EmitNull
      Emit  LocalDo$ + "DoLoop_" + Num$(InLoop) + "A:"


'Ŀ
' EXIT LOOP STATEMENT 
'

      CASE "EXITLOOP","EXITDO"
      PrintSrc

      IF InProc THEN
        LocalDo$ = Cap$(ProcName$)
      ELSE
        LocalDo$ = ""
      END IF

      InLoop = LoopPop
      Emit "Jmp " + LocalDo$ + "DoLoop_" + Num$(InLoop) + "A"
      LoopPush InLoop



'Ŀ
'  FOR STATEMENT  
'

      CASE "FOR"
      PrintSrc

      Resolve2            'get Variable
      Resolve4            'get Start
      Resolve6            'get End
      Resolve Stk$(8)

      IF Stk$(8) = "" THEN Stk$(8) = "1"                        'step default
      IF Not IsInteger(Stk$(8)) THEN Stk$(8)=AddVar$(Stk$(8))   'get step Value


      IF IsInteger(Stk$(4)) and IsInteger(Stk$(8)) THEN
        Tmp = Val(Stk$(4)) - VAL(Stk$(8))
        Emit "Mov  " + Stk$(2) + "," + LTRIM$(STR$(Tmp))
      ELSE
        Emit "Mov  AX," + Stk$(4)
        IF Stk$(8) = "1" THEN
          Emit "Dec  AX"
        ELSE
          Emit "Sub  AX," + Stk$(8)
        END IF
        Emit "Mov  "   + Stk$(2) + ",AX"
      END IF


      IF InProc THEN
        LocalFor$=Cap$(ProcName$)
      ELSE
        LocalFor$=""
      END IF

      INCR ForVar
      ForPush ForVar

      Tmp1$ = LocalFor$ + "ForLoop_" + Num$(ForVar)
      Tmp2$ = Tmp1$ + ":"
      Tmp1$ = Tmp1$ + "_Ok"
      Emit Tmp2$
      LastForLoop$ = LocalFor$ + "Next_" + Num$(ForVar)
      StepLabel$   = LocalFor$ + "ForLoop_" + Num$(ForVar) + "_StepDn"

      IF Stk$(8) = "1" THEN
        Emit "Inc  " + Stk$(2)                 'optimization
      ELSE
        Emit "Mov  AX," + Stk$(8)
        Emit "Add  " + Stk$(2) + ",AX"


      END IF

      IF (IsInteger(Stk$(8))) AND (Val(Stk$(8)) > 0) = 0 THEN
        Emit "Mov  AX," + Stk$(8)
        Emit "Cmp  AX,0"
        Emit "Jl   " + StepLabel$
      END IF

'***************************************
'         if step is positive
'***************************************
      Emit "Mov  AX," + Stk$(2)
      Emit "Cmp  AX," + Stk$(6)'      'Ascending Step
      Emit "Jle  "    + Tmp1$
      Emit "Jmp  "    + LastForLoop$
'***************************************
'       if step is negative
'***************************************
      IF (IsInteger(Stk$(8))) AND (Val(Stk$(8)) > 0) = 0 THEN
        Emit StepLabel$ + ":"
        Emit "Mov  AX," + Stk$(6)
        Emit "Cmp  AX," + Stk$(2)       'Descending Step
        Emit "Jle  "    + Tmp1$
        Emit "Jmp  "    + LastForLoop$
      END IF
'***************************************
'       in all cases emit this label
'***************************************
      Emit Tmp1$      + ":"

'Ŀ
'  NEXT STATEMENT  
'

      CASE "NEXT"
      PrintSrc

      IF InProc THEN
        LocalFor$ = Cap$(ProcName$)
      ELSE
        LocalFor$ = ""
      END IF

      NextVar = ForPop

      Emit "Jmp "  + LocalFor$ + "ForLoop_" + Num$(NextVar)
      LastForLoop$ = LocalFor$ + "Next_" + Num$(NextVar)
      Emit  LastForLoop$ + ":"


'Ŀ
'  EXIT FOR STATEMENT  
'

      CASE "EXITFOR"
      PrintSrc

      IF InProc THEN
        LocalFor$ = Cap$(ProcName$)
      ELSE
        LocalFor$ = ""
      END IF

      NextVar = ForPop
      Emit "Jmp " + LocalFor$ + "Next_" + Num$(NextVar)
      ForPush NextVar

'Ŀ
' REPEAT STATEMENT 
'

      CASE "REPEAT"
      PrintSrc
      Resolve2
      Emit "Mov  CX,"+ Stk$(2)
      INCR ReptCount
      RepeatPush ReptCount

      IF InProc THEN
        LocalRepeat$ = Cap$(ProcName$)
      ELSE
        LocalRepeat$ = ""
      END IF
      Emit LocalRepeat$ + "Repeat_" + Num$(ReptCount) +":"
      Emit "Push CX

'Ŀ
' EXIT REPEAT STATEMENT 
'

      CASE "ENDREPEAT"
      PrintSrc
      Emit "Pop CX

      IF InProc THEN
        LocalRepeat$ = Cap$(ProcName$)
      ELSE
        LocalRepeat$ = ""
      END IF

      Emit "Loop " + LocalRepeat$ + "Repeat_" + Num$(RepeatPop)



'Ŀ
'  CALL STATEMENT  
'

      CASE "CALL"
      PrintSrc
      FOR Tmp = Tokens TO 3 STEP -1
        Tmp$ = Stk$(Tmp)
        ResolveTmp
        TheDataType = Datatype(Tmp$)

        IF IsUsrFunc(Tmp$) THEN
          Emit "Push Offset " + Tmp$
        ELSEIF TheDatatype = %NumVar OR TheDataType = %Number THEN

          IF IsArray(Tmp$) OR IsProc(Tmp$) THEN
            Emit "Push Offset "   + Tmp$
          ELSE
            Emit "Push Word Ptr " + Tmp$
          END IF

        ELSEIF TheDataType = %StrVar THEN
          Push Tmp$
        END IF
      NEXT
      Resolve2
      Emit "Call " + Stk$(2)

'Ŀ
'  SUB & FUNCTION STATEMENT  
'

      CASE "SUB","FUNCTION"
      InProc = %True
      StackPointer = 0    ' This is referenced in the LOCAL case block
      EmitNull
      EmitNull

      IF Switch$ = "FUNCTION"  THEN
        IF DataType(Stk$(2)) = %StrVar THEN  AddVar "$STRFUNC"
      END IF

      IF MemModel = 2 then
        TmpModel$ = "Near"
      ELSE
        TmpModel$ = "Far"
      END IF


      Emit Cap$(Stk$(2)) + " Proc " + TmpModel$
      Emit "Public " + Cap$(Stk$(2))
      Emit "Push BP"
      Emit "Mov  BP,SP"
      ProcName$ = UCASE$(Stk$(2))


'Ŀ
'  ENDSUB -EXITSUB-ENDFUNCTION-EXITFUNCTION  
'

      CASE "ENDSUB","EXITSUB","ENDFUNCTION","EXITFUNCTION"
      Emit "Mov  SP,BP"
      Emit "Pop  BP"

      FOR Tmp = 1 TO ProcCount
        IF Proc$(Tmp,1) = ProcName$ THEN EXIT FOR
      NEXT

      TmpModel$ = " "

      IF MemModel = 4 then TmpModel$ = "F"

      PopWord = Val(Proc$(Tmp,2))*2
      Tmp$ = Num$(PopWord)
      IF Tmp$ = "00" THEN
        Emit "Ret" + TmpModel$
      ELSE
        Emit "Ret" + TmpModel$ + " " + Tmp$
      END IF

      IF Switch$ = "ENDSUB" OR Switch$ = "ENDFUNCTION"  THEN
        Emit  Cap$(ProcName$) + " Endp"
        InProc = %False
        Redim LocalTable$(%TableSize)
        LocalTablePtr = 0
      END IF


'Ŀ
' DEFSEG 
'

      CASE "DEFSEG"
      PrintSrc
      Emit "Push $DataSeg"
      Emit "Push $DataSeg"
      Emit "Pop  DefSeg"
      Emit "Pop  DS"

'Ŀ
' MoveMem  
'

      CASE "MOVEMEM"      ' MoveMem ( SSeg,Sofs, DSeg,Dofs,Bytes )

      PrintSrc

      Resolve2
      Resolve3
      Resolve4
      Resolve5
      Resolve6


      Push Stk$(6)
      Push Stk$(5)
      Push Stk$(4)
      Push Stk$(3)
      Push Stk$(2)
      Emit "Call MoveMem"
      Use.MoveMem = %True

'Ŀ
' Release  
'

      CASE "RELEASE"              ' Release Segment
      PrintSrc
      Resolve2
      LoadRegister "AX",Stk$(2)
      Emit "Call Release"
      Use.Release = %True


'Ŀ
' LOCAL 
'

      CASE "LOCAL"
      PrintSrc

      FOR Tmp = 2 to Tokens
        INCR LocalTablePtr
        LocalTable$(LocalTablePtr) = UCASE$(Stk$(Tmp))
        IF DataType(Stk$(Tmp)) = %StrVar THEN
          Tmp$ = "L_" + REMOVE$(Procname$,"$") + "_"
          Var$ = AddVar$(Tmp$ + Stk$(Tmp))
          Emit  "Mov  DI,Offset " + Cap$(Var$)
          Emit  "Mov  [DI],Byte Ptr 0"
        ELSE
          Tmp$ = "L_" + Cap$(REMOVE$(Procname$,"$")) + "_"
          Var$ =  Tmp$ + Stk$(Tmp)
          Incr LocalNameCount
          LocalName$(LocalNameCount) = UCASE$(Var$)
          INCR StackPointer,2     'Is reset with each new SUB/FUNCTION statement
          Emit "Sub  SP,2"
          Emit  Var$ + "  Equ  Word Ptr [BP-"  + Num$(StackPointer) + "]"
          EmitNull
          Emit "Mov  " + Var$ + ",0"
          EmitNull
        END IF
      NEXT



'Ŀ
'  INCR Statement  
'

      CASE "INCR","INC"
      PrintSrc
      Resolve2
      Resolve3
      IF Stk$(3) = "" THEN
        Emit "Inc  " + Stk$(2)
      ELSE
        IF DataType (Stk$(3)) = %Number THEN
          Emit "Add   "    + Stk$(2) +  "," + Stk$(3)
        ELSE
          Emit "Mov   BX," + Stk$(3)
          Emit "Add   "    + Stk$(2) +  ",BX"
        END IF
      END IF

'Ŀ
'  DECR Statement  
'

      CASE "DECR","DEC"
      PrintSrc
      Resolve2
      Resolve3
      IF Stk$(3) = "" THEN
        Emit "Dec  " + Stk$(2)
      ELSE
        IF DataType (Stk$(3)) = %Number THEN
          Emit "Sub   "    + Stk$(2) +  "," + Stk$(3)
        ELSE
          Emit "Mov   BX," + Stk$(3)
          Emit "Sub   "    + Stk$(2) +  ",BX"
        END IF
      END IF

'Ŀ
'  SHL/SHR Statements  
'

      CASE "SHL","SHR"

      V1$ = Cap$(Stk$(1))

      PrintSrc
      Resolve2
      Resolve3

      IF Stk$(3) = "" THEN
        Stk$(3) = "1"
      END IF

      IF DataType(Stk$(3)) <> %Number THEN
        Emit "Mov  CX," + Stk$(3)
        Emit V1$  + " " +  Stk$(2)  +  ",CL"
      ELSE
        Emit V1$  + " " +  Stk$(2)  +  "," + Stk$(3)
      END IF

'Ŀ
' OUT Statement  
'

      CASE "OUT"
      PrintSrc
      Resolve2
      Resolve3
      Emit "Mov  DX," + Stk$(2)
      Emit "Mov  AX," + Stk$(3)
      Emit "Out  DX,AL"


'Ŀ
'     GETKEY     
'

      CASE "GETKEY"
      PrintSrc
      Emit "Call GetKey"
      Use.GetKey = %True


'Ŀ
'  PRINT STATEMENT  
'

      CASE "PRINT","GPRINT"
      PrintSrc
      IF Switch$ = "PRINT"  THEN Use.PrintStr = %True
      IF Switch$ = "GPRINT" THEN Use.GPrint  = %True

      Use.Len       = %True
      Use.SetCursor = %True

'[ IF no PrintObject THEN ? CrLf ]

      IF Tokens = 1 THEN
        Emit "Call DoCrLf"
        Use.DoCrLf = %True
        EXIT SELECT
      END IF

      IF Tokens = 2 THEN
        IF Stk$(2) = ";" THEN
          Emit "Call SetCursor"
          EXIT SELECT
        END IF
      END IF

      COUNT = Tokens

      IF Stk$(Tokens) = ";" THEN
        DECR COUNT
      END IF

      FOR Tmp = 2 TO COUNT
        Tmp$ = Stk$(Tmp)

        IF UCASE$(Tmp$) = "TAB" THEN
          Incr Tmp
          Tmp$ = Stk$(Tmp)
          ResolveTmp
          Emit "Mov  AX,"+Tmp$
          Emit "Mov  $Xcur,AX"
          Incr Tmp
          Tmp$ = Stk$(Tmp)
        END IF

        IF UCASE$(Tmp$) = "TIME$" THEN
          Use.Work1   =  %True
          Use.Len     =  %True
          Use.Concat2 =  %True
          Use.Time     = %True
          Emit "Call Time"
          Emit "Mov  SI,Offset $_1_"
          IF Switch$ = "PRINT"  THEN Emit "Call PrintStr"
          IF Switch$ = "GPRINT" THEN Emit "Call GPrint"
          Emit "Call SetCursor"
          Goto PrintLabel
        END IF

        IF UCASE$(Tmp$) = "DATE$" THEN
          Use.Work1   =  %True
          Use.Len     =  %True
          Use.Concat2 =  %True
          Use.Date     = %True
          Emit "Call Date"
          Emit "Mov  SI,Offset $_1_"
          IF Switch$ = "PRINT"  THEN Emit "Call PrintStr"
          IF Switch$ = "GPRINT" THEN Emit "Call GPrint"
          Emit "Call SetCursor"
          Goto PrintLabel
        END IF


        IF DataType(Tmp$) = %StrVar THEN
          ResolveTmp
          LoadRegister "SI",Tmp$
          IF Switch$ = "PRINT"  THEN Emit "Call PrintStr"
          IF Switch$ = "GPRINT" THEN Emit "Call GPrint"
          Emit "Call SetCursor"
          Use.Len      = %True
        ELSE
          ResolveTmp
          TheDataType = DataType(Tmp$)
          Emit "Mov  AX," + Tmp$
          IF Switch$ = "PRINT"  THEN Emit "Call PrintNum"   : Use.PrintNum = %True
          IF Switch$ = "GPRINT" THEN Emit "Call GPrintNum"  : Use.GPrintNum = %True
          Use.Str      = %True
          Use.Len      = %True
          Use.Work1    = %True
        END IF
        PrintLabel:
      NEXT

      Tmp$ = EXTRACT$(SourceLine$,"'")
      Tmp$ = RTRIM$(Tmp$)
      Tmp$ = RIGHT$(Tmp$,1)

      IF Tmp$ <> ";" THEN
        Emit "Call DoCrLf"
        Use.DoCRLF = %True
      END IF



'Ŀ
'  OUTPUT STATEMENT 
'

      CASE "OUTPUT"
      PrintSrc

      IF Tokens = 1 THEN
        EXIT SELECT
      END IF

      Use.Output    = %True

      COUNT = Tokens

      FOR Tmp = 2 TO COUNT
        Tmp$ = Stk$(Tmp)

        IF UCASE$(Tmp$) = "TIME$" THEN
          Use.Work1   =  %True
          Use.Len     =  %True
          Use.Concat2 =  %True
          Use.Time     = %True

          Emit "Call Time"
          Emit "Push Offset $_1_"
          Emit "Call Output"
          Goto OutputLabel
        END IF

        IF UCASE$(Tmp$) = "DATE$" THEN
          Use.Work1   =  %True
          Use.Len     =  %True
          Use.Concat2 =  %True
          Use.Date     = %True
          Emit "Call Date"
          Emit "Push Offset $_1_"
          Emit "Call Output"
          Goto OutputLabel
        END IF


        IF DataType(Tmp$) = %StrVar THEN
          ResolveTmp
          Push Tmp$
          Emit "Call Output"
          EmitNull
          Use.Len  = %True
        ELSE
          ResolveTmp
          Emit "Mov  AX," + Tmp$
          Emit "Xor  BX,BX"
          Emit "Mov  DI,Offset $_1_"
          Emit "Call Str$"
          Emit "Push Offset $_1_"
          Emit "Call Output"
          EmitNull
          Use.Str      = %True
          Use.Len      = %True
          Use.Work1    = %True
        END IF
        OutputLabel:
      NEXT

      Emit "Push Offset $CrLf2"
      Emit "Call Output"



'Ŀ
' LPRINT STATEMENT  
'

      CASE "LPRINT"
      PrintSrc

      Use.Len       =  %True
      Use.Lprint    =  %True
      Use.TrapError =  %True

      COUNT = Tokens

      IF Stk$(Tokens) = ";" THEN
        DECR COUNT
      END IF

      FOR Tmp = 2 TO COUNT
        Tmp$ = Stk$(Tmp)

        IF DataType(Tmp$) = %StrVar THEN
          ResolveTmp
          Emit "Push Offset " + Tmp$
          Emit "Call Lprint"
          EmitNull
        ELSE
          Tmp$ = AddVar$(Tmp$)
          Emit "Mov  DI,Offset $_1_"
          Emit "Mov  AX," + Tmp$
          Emit "Xor  BX,BX"
          Emit "Call Str$"
          Emit "Push Offset $_1_"
          Emit "Call Lprint"
          EmitNull
          Use.Str    = %True
          Use.Work1  = %True
        END IF
      NEXT

      Tmp$ = EXTRACT$(SourceLine$,"'")
      Tmp$ = RTRIM$(Tmp$)
      Tmp$ = RIGHT$(Tmp$,1)

      IF Tmp$ <> ";" THEN
        Emit "Call LprintNL"
        Use.LprintNL = %True
      END IF


'Ŀ
'GOSUB 
'

      CASE "GOSUB"
      PrintSrc
      Tmp = DataType(Stk$(2))
      Emit "Call " + Stk$(2)

'Ŀ
'RETURN 
'

      CASE "RETURN"
      PrintSrc
      Emit "Ret"


'Ŀ
' _LABEL   
'

      CASE "_LABEL"
      EmitNull
      Emit Stk$(2)


'Ŀ
' GOTO STATEMENT  
'

      CASE "GOTO"
      PrintSrc
      Emit "Jmp " + Stk$(2)


'Ŀ
' ArrayPut 
'

      CASE "ARRAYPUT"     'arrayput ( arrayname, element, Value )

      PrintSrc


      Check4Array

      IF DataType(Stk$(2)) = %StrVar THEN
        Resolve2
        Resolve3
        Resolve4
        Push Stk$(4)
        Push Stk$(3)
        Push Stk$(2)
        Emit "Call ArrayPut"
        Use.MoveStr  = %True
        Use.ArrayPut = %True
      ELSE
        Resolve2
        Resolve3
        Resolve4
        Emit "Mov  AX," + Stk$(3)
        Emit "Shl  AX,1"
'   Emit "Dec  AX"   ' wrong
        Emit "Mov  BX,Offset " + Stk$(2)
        Emit "Add  BX,AX"            'BX has address of array element
        IF DataType(Stk$(4)) = %Number THEN
          Emit "Mov  [BX],Word Ptr " + Stk$(4)
        ELSE
          Emit "Mov  AX," + Stk$(4)
          Emit "Mov  [BX],AX"
        END IF
      END IF


'Ŀ
' ArrayGet 
'

      CASE "ARRAYGET"     ' arrayget ( arrayname, element, Variablename )

      PrintSrc

      Check4Array

      IF DataType(Stk$(2)) = %StrVar THEN
        Resolve2
        Resolve3
        Resolve4
        Push Stk$(4)
        Push Stk$(3)
        Push Stk$(2)
        Emit "Call ArrayGet"
        Use.MoveStr  = %True
        Use.ArrayGet = %True

      ELSE
        Resolve2
        Resolve3
        Resolve4
        Emit "Mov  AX," + Stk$(3)
        Emit "Shl  AX,1"
'   Emit "Dec  AX"   ' wrong
        Emit "Mov  BX,Offset " + Stk$(2)
        Emit "Add  BX,AX"
        Emit "Mov  AX,[BX]"
        Emit "Mov  " + Stk$(4) + ",AX"
      END IF

'Ŀ
' ARRAYSORT 
'

      CASE "ARRAYSORT"

      PrintSrc

      IF Tokens < 3 THEN
        PRINT "Missing Parameter:"
        PRINT  SourceLine$
        PRINT "Aborting Compilation"
        END
      END IF

      Resolve2
      Resolve3

      Push Stk$(3)
      Push Stk$(2)
      Emit "Call ArraySort"

      Use.Work0      =  %True
      Use.Work1      =  %True
      Use.Arraysort  =  %True
      Use.StrCompare =  %True
      Use.MoveStr    =  %True
      Use.ArrayGet   =  %True
      Use.ArrayGet   =  %True



'Ŀ
' ARRAYINSERT 
'

      CASE "ARRAYINSERT"

      PrintSrc

      Check4Array

      Resolve2  'array
      Resolve3  'element
      Resolve4  'array size

      Push Stk$(4)
      Push Stk$(3)
      Push Stk$(2)
      Emit "Call ArrayInsert"
      Use.Work0        =  %True
      Use.ArrayInsert  =  %True
      Use.MoveStr      =  %True
      Use.ArrayGet     =  %True
      Use.ArrayPut     =  %True


'Ŀ
' ARRAYDELETE 
'

      CASE "ARRAYDELETE"

      PrintSrc

      Check4Array

      Resolve2  'array
      Resolve3  'element
      Resolve4  'array size

      Push Stk$(4)
      Push Stk$(3)
      Push Stk$(2)

      Emit "Call ArrayDelete"

      Use.Work0        =  %True
      Use.ArrayDelete  =  %True
      Use.MoveStr      =  %True
      Use.ArrayGet     =  %True
      Use.ArrayPut     =  %True


'Ŀ
' STATIC 
'

      CASE "STATIC"
      PrintSrc

      FOR Tmp = 2 to Tokens
        Var$ = AddVar$("L_" + REMOVE$(Procname$,"$") + "_" + Stk$(Tmp))
        INCR LocalTablePtr
        LocalTable$(LocalTablePtr) = UCASE$(Stk$(Tmp))
      NEXT

'Ŀ
'    POKE Statement    
'

      CASE "POKE"
      PrintSrc

      Use.Poke = %True
      Resolve2
      Resolve3
      V1$ = Stk$(2)
      V2$ = Stk$(3)
      While Len(V1$) < Len(V2$)
        V1$ = V1$ + " "
      WEND
      While Len(V2$) < Len(V1$)
        V2$ = V2$ + " "
      WEND
      Emit "Mov  DI," + V1$ + " ;Offset"
      Emit "Mov  BX," + V2$ + " ;Value"
      Emit "Call Poke"

'Ŀ
'    POKEI Statement   
'

      CASE "POKEI"
      PrintSrc

      Resolve2
      Resolve3
      V1$ = Stk$(2)
      V2$ = Stk$(3)
      While Len(V1$) < Len(V2$)
        V1$ = V1$ + " "
      WEND
      While Len(V2$) < Len(V1$)
        V2$ = V2$ + " "
      WEND
      Emit "Mov  DI," + V1$ + " ;Offset"
      Emit "Mov  BX," + V2$ + " ;Value"
      Emit "Call PokeI"
      Use.Pokei = %True

'Ŀ
'  MID$ Statement  
'

      CASE "MID$"

      PrintSrc
      Resolve2
      Resolve3
      Resolve5
      Push Stk$(5)
      Push Stk$(3)
      Push Stk$(2)
      Emit "Call Midd"
      Use.Midd    =  %True
      Use.Space   =  %True
      Use.ClrWork =  %True
      Use.Concat2 =  %True
      Use.MoveStr =  %True
      Use.Assign  =  %True


'Ŀ
'  REPLACE  Statement  
'

      CASE "REPLACE"

      PrintSrc

      Resolve2
      Resolve4
      Resolve6


'*** transfer 3 parameters TO Work space Variables ***

      LoadRegister "SI",Stk$(2)
      Emit "Mov  DI,Offset $_2_"
      Emit "Call MoveStr"
      LoadRegister "SI",Stk$(4)
      Emit "Mov  DI,Offset $_3_"
      Emit "Call MoveStr"
      LoadRegister "SI",Stk$(6)
      Emit "Mov  DI,Offset $_4_"
      Emit "Call MoveStr"
      Emit "Call Replace"
      Emit "Mov  SI,Offset $_0_"
      LoadRegister "DI",Stk$(6)
      Emit "Call MoveStr"
      Use.Replace    =  %True
      Use.Concat2    =  %True
      Use.Len        =  %True
      Use.StrCompare =  %True
      Use.MoveStr    =  %True
      Use.Work0      =  %True
      Use.Work1      =  %True
      Use.Work2      =  %True
      Use.Work3      =  %True
      Use.Work4      =  %True
      Use.Work5      =  %True


'Ŀ
'  ASM Statement  
'

      CASE "ASM"
      Emit LTRIM$(Stk$(2))

'Ŀ
' SWAP Statement  
'

      CASE "SWAP"
      PrintSrc
      Resolve2
      Resolve3
      IF DataType(Stk$(2)) = %StrVar THEN
        LoadRegister "SI",Stk$(2)
        Emit "Mov  DI,Offset $_0_"
        Emit "Call Movestr"
        LoadRegister "SI",Stk$(3)
        LoadRegister "DI",Stk$(2)
        Emit "Call Movestr"
        Emit "Mov  SI,Offset $_0_"
        LoadRegister "DI",Stk$(3)
        Emit "Call Movestr"
        Use.Movestr = %True
        Use.Work0   = %True
      ELSE
        Emit "Mov  AX," + Stk$(2)
        Emit "Mov  BX," + Stk$(3)
        Emit "Mov  "    + Stk$(2) + ",BX"
        Emit "Mov  "    + Stk$(3) + ",AX"
      END IF


'Ŀ
' DELAY  
'

      CASE "DELAY"

      PrintSrc
      Resolve2
      Emit "Mov  BX," + Stk$(2)
      Emit "Mov  AL,18
      Emit "Call Delay"
      Use.Delay = %True

'Ŀ
' PAUSE  
'

      CASE "PAUSE"

      PrintSrc
      Resolve2
      Emit "Mov  BX," + Stk$(2)
      Emit "Mov  AL,1
      Emit "Call Delay"
      Use.Delay = %True



'Ŀ
' BEEP 
'

      CASE "BEEP"
      PrintSrc
      Emit "Call Beep"
      Use.Beep = %True

'Ŀ
'   INPUT# STATEMENT   
'

      CASE "INPUT#"
      PrintSrc
      Handle$ = AddVar$("HANDLE_" + Stk$(2))

      FOR Tmp =  3 TO Tokens
        Resolve Stk$(Tmp)
        Var$ = Stk$(Tmp)
        TheDataType = DataType(Var$)

        InputScratch$ = ""
        IF TheDataType = %Number or TheDataType = %Numvar THEN
          InputScratch$ = Var$
          Var$ = "$_0_"
        END IF

        EmitNull
        Emit "Mov  " + Var$ + ",0"
        LoadRegister "DI",Var$
        Emit "Mov  AX," + Handle$
        Emit "Call DiskInput"

        IF InputScratch$ > "" THEN
          LoadRegister "DI","$_0_"
          Emit "Call Val"
          Use.Val = %True
          Emit "Mov  " + InputScratch$ + ",AX"
        END IF

      NEXT
      Use.DiskInput    =  %True
      Use.Len          =  %True
      Use.TrapError    =  %True
      Use.Work0        =  %True
      Use.Work1        =  %True



'Ŀ
' LINE INPUT# STATEMENT 
'

      CASE "LINEINPUT#"

      PrintSrc
      Handle$ = AddVar$("HANDLE_" + Stk$(2))
      Resolve3
      Emit "Mov  " + Stk$(3) + ",0"
      Emit "Mov  AX," + Handle$
      Emit "Call LineInput"
      Emit "Mov  SI,Offset $FileBuf"
      Emit "Mov  DI,Offset " + Stk$(3)
      Emit "Call MoveStr"
      Use.MoveStr    = %True
      Use.FileBuf    = %True
      Use.LineInput  = %True
      Use.TrapError  = %True
      Use.Work1      = %True

'Ŀ
'   PRINT# STATEMENT   
'

      CASE "PRINT#"

      PrintSrc
      Use.Work1      =  %True
      Handle$ = AddVar$("HANDLE_" + Stk$(2))
      Suppress = %False
      IF Stk$(Tokens) = ";" THEN
        Suppress = %True
        DECR Tokens
      END IF

'***  resolve the Arguments ***

      FOR Tmp =  3 TO Tokens
        Var$ = Stk$(Tmp)

'************** allow numeric constants and numeric variables *************

        TheDataType = DataType(Var$)
        IF TheDataType = %Number or TheDataType = %NumVar THEN
          Emit "Mov  DI,Offset $_1_"
          Emit "Mov  AX," + Var$
          Emit "Call Str$"
          Var$="$_1_"
          Use.Str = %True
        END IF

'**************************************************************************

        Resolve Var$
        LoadRegister "SI",Var$
        Emit "Call Len"
        Emit "Mov  CX,AX"
        Emit "Mov  AX," + Handle$
        Emit "Mov  BX,AX"
        LoadRegister "DX",Var$
        Emit "Mov  AH,40h"
        Emit "Int  21h"
        Emit "Call TrapError"
      NEXT

      IF Suppress = %False THEN
        Emit "Mov  AX," + Handle$
        Emit "Mov  BX,AX"
        Emit "Mov  CX,2"
        Emit "Mov  DX,Offset $CrLf"
        Emit "Mov  AH,40h"
        Emit "Int  21h"
        Emit "Call TrapError"
      END IF

      Use.Zero      =  %True
      Use.Len       =  %True
      Use.TrapError =  %True


'Ŀ
'   PUTCHAR   
'

      CASE "PUTCHAR"            'PUTCHAR #1,a,b,c,d,...
      PrintSrc
      Use.PutChar = %True
      Handle$ = AddVar$("HANDLE_" + REMOVE$(Stk$(2),"#"))

      FOR Tmp = 3 to Tokens
        Resolve  Stk$(Tmp)
        Var$ = Stk$(Tmp)
        Emit "Mov  AX," + Var$
        Emit "Mov  BX," + Handle$
        Emit "Call PutChar"
      NEXT


'Ŀ
'  GETCHAR  
'

      CASE "GETCHAR"            'GETCHAR #1,a,b,c,d,...
      PrintSrc
      Use.GetChar = %True
      Handle$ = AddVar$("HANDLE_" + REMOVE$(Stk$(2),"#"))

      FOR Tmp = 3 to Tokens
        Resolve  Stk$(Tmp)
        Var$ = Stk$(Tmp)
        Emit "Mov  BX," + Handle$
        Emit "Call GetChar"
        Emit "Mov  " + Var$ + ",AX"
      NEXT


'Ŀ
'   PUT$   
'

      CASE "PUT$"
      PrintSrc
      Use.PutStr    = %True
      Use.TrapError = %True
      Handle$ = AddVar$("HANDLE_" + Stk$(2))
      Resolve  Stk$(3)
      Push Stk$(3)
      Push Handle$
      Emit "Call Put$"


'Ŀ
'   GET$   
'

      CASE "GET$"

      PrintSrc
      Use.GetStr    = %True
      Use.TrapError = %True
      Handle$ = AddVar$("HANDLE_" + Stk$(2))
      Resolve3
      Resolve4
      Push Stk$(4)
      Push Stk$(3)
      Push Handle$
      Emit "Call Get$"



'Ŀ
' OPEN STATEMENT 
'

      CASE "OPEN"
      PrintSrc

'***  resolve the FileName ***

      Resolve2
      FileName$ = Stk$(2)

'*** resolve the HANDLE****

      Handle$ = AddVar$("HANDLE_" + Stk$(6))
      AddHandleNumber Val(Stk$(6))

'*** resolve the file function ***

      IF UCASE$(Stk$(4)) = "OUTPUT" THEN
        LoadRegister "DX",FileName$
        Emit "Mov  AX,Offset " + Handle$
        Emit "Call CreateFile"
        Use.Createfile = %True
      END IF

      IF UCASE$(Stk$(4)) = "INPUT" THEN
        LoadRegister "DX",FileName$
        Emit "Mov  BX,Offset "+ Handle$
        Emit "Call ReadFile
        Use.ReadFile = %True
      END IF

      IF UCASE$(Stk$(4)) = "APPEND" THEN
        LoadRegister "DX",FileName$
        Emit "Call AppendFile"
        Use.AppendFile = %True
      END IF

      Use.Len       =  %True
      Use.TrapError =  %True
      Use.Handle    =  %True

'Ŀ
'  FLUSH STATEMENT  
'

      CASE "FLUSH"
      PrintSrc
      Var$ = AddVar$("HANDLE_" + Stk$(2))
      Emit "Mov  BX," + Var$
      Emit "Call FlushFile"
      Use.TrapError = %True
      Use.FlushFile = %True

'Ŀ
'  CLOSE STATEMENT  
'

      CASE "CLOSE"
      PrintSrc

      IF Stk$(2) > "" THEN
        Var$ = AddVar$("HANDLE_" + Stk$(2))
      END IF

      IF Stk$(2) = "" THEN
        FOR A = 1 to 25
          IF FileHandles(a) > 0 THEN
            Var$ = AddVar$("HANDLE_" + LTRIM$(STR$(FileHandles(A))))
            Emit "Mov  BX," + Var$
            Emit "Call CloseFile"
          END IF
        NEXT
      ELSE
        Emit "Mov  BX," + Var$
        Emit "Call CloseFile"
      END IF
      Use.TrapError = %True
      Use.CloseFile = %True

'Ŀ
'   KILL STATEMENT  
'

      CASE "KILL"
      PrintSrc
      Resolve2
      LoadRegister "DX",Stk$(2)
      Emit "Mov  AH,41h"
      Emit "Int  21h"
      Emit "Call TrapError"
      Use.TrapError = %True

'Ŀ
'  MKDIR STATEMENT  
'

      CASE "MKDIR"
      PrintSrc
      Resolve2
      LoadRegister "DX",Stk$(2)
      Emit "Mov  AH,39h"
      Emit "Int  21h"
      Emit "Call TrapError"
      Use.TrapError = %True


'Ŀ
'  CHDIR STATEMENT  
'

      CASE "CHDIR"
      PrintSrc
      Resolve2
      LoadRegister "DX",Stk$(2)
      Emit "Mov  AH,3Bh"
      Emit "Int  21h"
      Emit "Call TrapError"
      Use.TrapError = %True


'Ŀ
'  CHDRIVE STATEMENT  
'

      CASE "CHDRIVE"
      PrintSrc
      Resolve2
      LoadRegister "DX",Stk$(2)
      Emit "Mov  AH,0Eh"
      Emit "Int  21h"
      Emit "Call TrapError"
      Use.TrapError = %True

'Ŀ
'  RMDIR STATEMENT  
'

      CASE "RMDIR"
      PrintSrc
      Resolve2
      LoadRegister "DX",Stk$(2)
      Emit "Mov  AH,3ah"
      Emit "Int  21h"
      Emit "Call TrapError"
      Use.TrapError = %True

'Ŀ
'   NAME STATEMENT  
'

      CASE "NAME"
      PrintSrc
      Resolve2
      Resolve4
      LoadRegister "DX",Stk$(2)
      LoadRegister "DI",Stk$(4)
      Emit "Mov  AH,56h"
      Emit "Int  21h"
      Emit "Call TrapError"
      Use.TrapError = %True

'Ŀ
'  END  Statement  
'

      CASE "END"
      PrintSrc
      Resolve2
      IF Stk$(2) = "" THEN Stk$(2) = "0"
      Emit "Mov  AL," + Stk$(2)
      Emit "Mov  AH,4Ch"
      Emit "Int  21h"


'Ŀ
'  COLOR STATEMENT  
'

      CASE "COLOR"
      PrintSrc

      Resolve2
      Resolve3

      IF IsInteger (Stk$(2)) THEN
        Emit "Mov  FgColor," + Stk$(2)
      ELSE
        Emit "Mov  AX," + Stk$(2)
        Emit "Mov  FgColor,AX"
      END IF

      IF IsInteger (Stk$(3)) THEN
        Emit "Mov  BgColor," + Stk$(3)
      ELSE
        Emit "Mov  AX," + Stk$(3)
        Emit "Mov  BgColor,AX"
      END IF

      Emit "Call SetAttribute"
      Use.Color = %True

'Ŀ
'  LOCATE STATEMENT  
'

      CASE "LOCATE"
      PrintSrc
      Resolve2
      Resolve3
      IF IsInteger (Stk$(2)) THEN
        Emit "Mov  $Ycur," + Stk$(2)
      ELSE
        Emit "Mov  AX," + Stk$(2)
        Emit "Mov  $Ycur,AX"
      END IF
      IF IsInteger (Stk$(3)) THEN
        Emit "Mov  $Xcur," + Stk$(3)
      ELSE
        Emit "Mov  AX," + Stk$(3)
        Emit "Mov  $Xcur,AX"
      END IF


      IF Tokens = 4 THEN
        Resolve4
        Emit "Mov  AX," + Stk$(4)
        Emit "Call ShowHideCursor"
        Use.ShowHideCursor = %True
      END IF

      Use.ShowHideCursor = %True


'Ŀ
'  CLS STATEMENT  
'

      CASE "CLS"
      PrintSrc
      Use.Cls = %True
      Emit "Call Cls"

'Ŀ
'  INPUT STATEMENT  
'

      CASE "INPUT","GINPUT"
      PrintSrc
      Use.KBinput   = %True
      IF Switch$ = "INPUT"  THEN Use.PrintStr = %True
      IF Switch$ = "GINPUT" THEN Use.GPrint = %True
      Use.Len       = %True
      Use.MoveStr   = %True
      Use.SetCursor = %True
      Use.DoCrLf    = %True
      Use.Work0     = %True

      Resolve2    'Prompt
      Resolve3    'Variable

      LoadRegister "SI",Stk$(2)
      IF Switch$ = "INPUT"  THEN  Emit "Call PrintStr"
      IF Switch$ = "GINPUT" THEN  Emit "Call GPrint"
      Emit "Call KBInput"

      IF DataType (Stk$(3)) = %StrVar THEN
        Emit "Mov  SI,Offset $_0_"
        LoadRegister "DI",Stk$(3)
        Emit "Call MoveStr"
      ELSE
        Emit "Mov  DI,Offset $_0_"
        Emit "Call Val"
        Emit "Mov " + Stk$(3) + ",AX"
        Use.VAL = %True
      END IF

'[ Do we suppress the CrLf maybe? ]

      IF Stk$(Tokens) = ";" THEN
        IF DataType (Stk$(3)) = %StrVar THEN
          Emit ";*** Suppress cr/lf ***"
          Emit "Mov  AX,$Var1"
          Emit "Dec  AX"
          Emit "Dec  AX"
          Emit "Mov  $Xcur,AX"
          Emit "Mov  AX,$Var3
          Emit "Add  $Xcur,AX"
          Emit "Mov  AX,$Var2"
          Emit "Mov  $Ycur,AX"
          Emit "Call SetCursor"
        ELSE
          Emit ";*** Suppress cr/lf ***"
          Emit "Mov  AX,$Var1"
          Emit "Inc  AX"
          Emit "Mov  $Xcur,AX"
          Emit "Mov  AX,$Var3
          Emit "Add  $Xcur,AX"
          Emit "Mov  AX,$Var2"
          Emit "Mov  $Ycur,AX"
          Emit "Call SetCursor"
        END IF
      END IF

'Ŀ
' CHANGEATTR 
'

      CASE "CHANGEATTR"
      PrintSrc

      Use.ChangeAttr =  %True
      Use.Poke       =  %True
      Use.VideoCard  =  %True

      FOR Ptr = 6 TO 2 STEP -1
        ResolvePtr
        Emit "Push " + Stk$(Ptr)
      NEXT
      Emit "Call ChangeAttr"

'Ŀ
' Frame 
'

      CASE "FRAME"
      PrintSrc

      FOR Tmp = 5 TO 2 STEP -1
        Resolve Stk$(Tmp)
        Emit "Push "+Stk$(Tmp)
      NEXT
      Emit "Call Frame"

      Use.Work2     = %True
      Use.Work3     = %True
      Use.SpcVar    = %True
      Use.Frame     = %True
      Use.Concat2   = %True
      Use.Repeat    = %True
      Use.MoveStr   = %True
      Use.PrintStr  = %True
      Use.SetCursor = %True
      Use.DoCrLf    = %True


'Ŀ
' GETSCREEN 
'

      CASE "GETSCREEN"

      PrintSrc
      Resolve2
      Emit "Mov  AX," + Stk$(2)
      Emit "Call GetScreen"
      Use.GetScreen = %True
      Use.VideoCard = %True



'Ŀ
' PUTSCREEN 
'

      CASE "PUTSCREEN"

      PrintSrc
      Resolve2
      Emit "Mov  AX," + Stk$(2)
      Emit "Call PutScreen"
      Use.PutScreen = %True
      Use.VideoCard = %True



'Ŀ
' SHELL 
'

      CASE "SHELL"
      PrintSrc

      Resolve2
      Push    Stk$(2)
      Emit "Call Shell"

      Use.MoveStr = %True
      Use.Concat2 = %True
      Use.Work2   = %True
      Use.Shell   = %True

'Ŀ
' PSET 
'

      CASE "PSET"
      PrintSrc
      Use.Pset = %True
      Resolve2
      Resolve3
      Resolve4
      IF Tokens = 3 THEN
        Stk$(4) = "15"
      END IF
      Emit "Mov  CX," + Stk$(2)
      Emit "Mov  $Xcur,CX"
      Emit "Mov  DX," + Stk$(3)
      Emit "Mov  $Ycur,DX"
      Emit "Mov  AX," + Stk$(4)
      Emit "Call Pset"

'Ŀ
' GET  
'

      CASE "GET"
      PrintSrc
      Use.Get    =  %True
      Use.Point  =  %True
      FOR Tmp = 6 to 2 STEP -1
        Resolve Stk$(Tmp)
        Push Stk$(Tmp)
      NEXT
      Emit "Call Get"


'Ŀ
' PUT  
'

      CASE "PUT"
      PrintSrc
      Use.Put    =  %True
      Use.Point  =  %True
      Use.Pset   =  %True
      FOR Tmp = 4 to 2 STEP -1
        Resolve Stk$(Tmp)
        Push Stk$(Tmp)
      NEXT
      Emit "Call Put"


'Ŀ
' Line 
'

      CASE "LINE"

      PrintSrc

      Use.Line =   %True
      Use.Pset      =   %True

      IF Tokens = 5 THEN
        Stk$(6) = "15"
      END IF

      SWAP Stk$(2),Stk$(3)
      SWAP Stk$(4),Stk$(5)

      Resolve2
      Resolve3
      Resolve4
      Resolve5
      Resolve6

      Emit "Mov  AX," + Stk$(2)
      Emit "Mov  BX," + Stk$(3)
      Emit "Mov  CX," + Stk$(4)
      Emit "Mov  DX," + Stk$(5)
      Emit "Mov  SI," + Stk$(6)
      Emit "Call Line"

'Ŀ
' LineTo 
'

      CASE "LINETO"

      PrintSrc

      Use.LineTo  =  %True
      Use.Line    =  %True
      Use.Pset    =   %True

      IF Tokens = 3 THEN
        Stk$(4) = "15"
      END IF

      Resolve2
      Resolve3
      Resolve4

      Push Stk$(4)
      Push Stk$(3)
      Push Stk$(2)

      Emit "Call LineTo"

'Ŀ
' PRESET 
'

      CASE "PRESET"
      PrintSrc

      Resolve2
      Resolve3

      Emit "Mov AX,"+Stk$(2)
      Emit "Mov $Xcur,AX"
      Emit "Mov AX,"+Stk$(3)
      Emit "Mov $Ycur,AX"


'Ŀ
' Circle 
'

      CASE "CIRCLE"
      Use.Circle = %True
      PrintSrc

      FOR Tmp = 2 to 7
        Tmp$ = Stk$(Tmp)
        ResolveTmp
        Emit "Push " + Tmp$
      NEXT

      Emit "Call Circle"


'Ŀ
' PAINT  
'

      CASE "PAINT"               'paint x,y,bg,fg
      Use.Paint = %True
      Use.Line  = %True
      Use.Point = %True
      Use.Pset  = %True

      PrintSrc

      FOR Tmp = 5 to 2 step -1
        Tmp$ = Stk$(Tmp)
        ResolveTmp
        Emit "Push " + Tmp$
      NEXT

      Emit "Call Paint"
'Ŀ
' SETVESA 
'

      CASE "SETVESA"

      PrintSrc

      Resolve2

      Emit "Mov  AX,4F02h"
      Emit "Mov  BX," + Stk$(2)
      Emit "Int  10h"


'Ŀ
' SCREEN 
'

      CASE "SCREEN"
      PrintSrc

      Use.Screen = %True

      Tmp = Val(Stk$(2))

      SELECT CASE Tmp

        CASE 0
        Emit "Push 3"
        Emit "Call Screen"


        CASE 2
        Emit "Push 4"
        Emit "Call Screen"


        CASE 7
        Emit "Push 0Dh"
        Emit "Call Screen"


        CASE 8
        Emit "Push 0Eh"
        Emit "Call Screen"


        CASE 9
        Emit "Push 10h"
        Emit "Call Screen"


        CASE 10
        Emit "Push 0Fh"
        Emit "Call Screen"


        CASE 11
        Emit "Push 11h"
        Emit "Call Screen"


        CASE 12
        Emit "Push 12h"
        Emit "Call Screen"


        CASE 13
        Emit "Push 13h"
        Emit "Call Screen"


      END SELECT

      CASE "SCREENON"
      PrintSrc
      Emit "Mov  AX,1200h"
      Emit "Mov  BL,36h"
      Emit "Int  10h"


      CASE "SCREENOFF"
      PrintSrc
      Emit "Mov  AX,1201h"
      Emit "Mov  BL,36h"
      Emit "Int  10h"


'Ŀ
' Sound Statement  
'

      CASE "SOUND"
      PrintSrc
      Resolve2
      Resolve3
      Emit "Push " + Stk$(3)
      Emit "Push " + Stk$(2)
      Emit "Call Sound"
      Use.Sound = %True
      Use.Delay = %True

'Ŀ
' ATTRIB STATEMENT 
'

      CASE "ATTRIB"
      PrintSrc
      Resolve2
      Resolve3

      Emit "Mov  AX,4301h"
      Emit "Mov  CX," + Stk$(3)
      Emit "Mov  DX,Offset " + Stk$(2)
      Emit "Int  21h


'Ŀ
' BLANK 
'

      CASE "BLANK"
      PrintSrc
      Resolve2
      Resolve3
      Resolve4
      Resolve5
      Emit "Push " + Stk$(5)
      Emit "Push " + Stk$(4)
      Emit "Push " + Stk$(3)
      Emit "Push " + Stk$(2)
      Emit "Call Blank"
      Use.Blank = %True

'Ŀ
' SetBorder 
'

      CASE "SETBORDER"
      PrintSrc
      Resolve2
      Emit "Mov  BX," + Stk$(2)
      Emit "Mov  AH,0BH"
      Emit "Int  10h

'Ŀ
' $COM   
'

      CASE "$COM"
      CodeType = %ComType


'Ŀ
' $EXE   
'

      CASE "$EXE"
      CodeType = %ExeType


'Ŀ
' $STACK 
'

      CASE "$STACK"
      SysStack = Val(Stk$(2))

'Ŀ
'$SOURCE METASTATEMENT 
'

      CASE "$SOURCE"

      SELECT CASE UCASE$(Stk$(2))
        CASE "ON",""
        SourceFlag% = 1

        CASE "OFF"
        SourceFlag% = 0
      END SELECT


'Ŀ
'$STRING METASTATEMENT 
'

      CASE "$STRING"
      BasmStrings = Val(Stk$(2))

      IF BasmStrings < 81 THEN
        BasmStrings = 81
      END IF

'Ŀ
'RESTORE 
'

      CASE "RESTORE"
      PrintSrc
      Emit "Mov $DataCtr,2"


'Ŀ
'READ 
'

      CASE "READ"
      PrintSrc
      Use.Index = %True
      FOR A = 2 TO Tokens
        Resolve Stk$(A)
        Emit "Call _Index"
        IF DataType (Stk$(A)) = %StrVar THEN
          Emit "Mov  " + Stk$(A) + ",AL"
          Emit "Mov  " + Stk$(A) + "+1,Byte Ptr 0"
        ELSE
          Emit "Mov  " + Stk$(A) + ",AX"
        END IF
        EmitNull
      NEXT

'Ŀ
' SETRGB 
'

      CASE "SETRGB"
      PrintSrc

      FOR Tmp = 4 TO 2 step -1
        Resolve Stk$(Tmp)
        Emit "Push "+Stk$(Tmp)
      NEXT
      Emit "Call SetRGB"

      Use.SetRGB = %True

'************************************************************************

      CASE ELSE

'************************************************************************

      FOR Tmp = 1 TO ProcCount + 1
        IF Proc$(Tmp,1) = Switch$ THEN
          EXIT FOR                  '*** assume it's a procedure call ****
        ELSE
          IF Tmp >= ProcCount AND Proc$(Tmp,1) <> Switch$ THEN
            PRINT "Error: Unrecognized Command (" ; Num$(LineNo) ; ") " ; SourceLine$
            EXIT SELECT      'unrecognized command ... don't assemble it
          END IF
        END IF
      NEXT

      PrintSrc

      FOR Tmp = Tokens TO 2 STEP -1
        Tmp$ = Stk$(Tmp)
        ResolveTmp

        TheDatatype = Datatype (Tmp$)

        IF TheDatatype = %NumVar OR TheDataType = %Number THEN
          IF IsArray(Tmp$) or IsProc(Tmp$) THEN
            Emit "Push Offset " + Tmp$
          ELSE
            Emit "Push Word Ptr " + Tmp$
          END IF
        END IF

        IF TheDataType = %StrVar THEN
          Emit "Push Offset " + Tmp$
        END IF

      NEXT
      Resolve  Stk$(1)
      Emit "Call " + Stk$(1)

'************************************************************************

    END SELECT
  END IF

  BasicCode$(LineNo)=""   '************  free some memory  **************

NEXT


'Ŀ
'    Write out the terminate to DOS code     
'

EmitNull
Emit "ExitToDos:"
EmitNull
Emit "Mov  AH,4Ch"
Emit "Xor  AL,AL"
Emit "Int  21h"
EmitNull
EmitNull

'
' This is where the user defined SUBS and PROCS come in
'
'

CLOSE #4

? #2,";************** User Defined SUBS & FUNCTIONS ***************"

OPEN SubProcs$ FOR INPUT AS #4
WHILE NOT EOF(4)
  LINE INPUT #4,A$
  PRINT #2,A$
WEND

? #2,""
? #2,";*************  BASM Library Code Begins Here  **************"

CLOSE #4

KILL SubProcs$


'Ŀ
' Include any necessary library code 
'

$SEGMENT
$INCLUDE "BASMLIB1.BAS"
$INCLUDE "BASMLIB2.BAS"
$INCLUDE "BASMLIB3.BAS"
$INCLUDE "BASMPROC.BAS"
